import 'package:endless/stream/endless_stream_list_view.dart';
import 'package:flutter/material.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: const MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({Key? key, required this.title}) : super(key: key);

  final String title;

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: EndlessStreamListView<MockItem>(
        loadMore: () {
          streamController.add([
            MockItem(title: 'Item 1'),
          ]);
        },
        stream: streamController.stream,
        itemBuilder: (
          context, {
          required item,
          required index,
          required totalItems,
        }) {
          return Container(
            color: Colors.purple,
            child: Text(item.title,
                style: TextStyle(color: Colors.red, fontSize: 23)),
          );
        },
      ),
    );
  }
}
